﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Devart.Data.Oracle;

namespace Stimulsoft.Report.DotConnectOracle
{
    public partial class DotConnectOracleConnectionEditor : Form
    {
        private OracleConnection connection = new OracleConnection();

        public DotConnectOracleConnectionEditor(string connString)
        {
            InitializeComponent();


            connection.ConnectionString = connString;
            
            edUsername.Text = ConvertToString(connection.UserId);
            edPassword.Text = ConvertToString(connection.Password);
            edServer.Text = ConvertToString(connection.Server);
            //edPort.Value = connection.Port;
        }

        private string ConvertToString(object obj)
        {
            if (obj == null)
                return String.Empty;
            else
                return obj.ToString();
        }

        private string connectionString;
        public string ConnectionString
        {
            get
            {
                return connectionString;
            }
        }

        private string BuildConnectString()
        {
            OracleConnectionStringBuilder sb = new OracleConnectionStringBuilder(connection.ConnectionString);
            sb.PersistSecurityInfo = true;
            
            sb.UserId = edUsername.Text;
            sb.Password = edPassword.Text;
            sb.Server = edServer.Text;
            //sb.Direct = cbDirect.Checked;
            //sb.Port = (int)edPort.Value;
            //sb.Sid = edSid.Text;

            connectionString = sb.ConnectionString;
            return connectionString;
        }

        private void btnTest_Click(object sender, EventArgs e)
        {
            try
            {
                BuildConnectString();
                Cursor.Current = Cursors.WaitCursor;
                connection.Open();
                Cursor.Current = Cursors.Default;
                MessageBox.Show("Test OK!");
                connection.Close();
            }
            catch (OracleException exception)
            {
                MessageBox.Show(exception.ToString());
            }
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void btnOk_Click(object sender, EventArgs e)
        {
            BuildConnectString();
            DialogResult = DialogResult.OK;
        }

        private void cbDirect_CheckedChanged(object sender, EventArgs e)
        {

        }
    }
}
